<?php
/**
* This script displays number o clicks
* Author: Stanislaw Polak
* Website: http://www.icsr.agh.edu.pl/~polak
* Version 1.0 (Dec 9, 2008)
*/


/**
 * Adjustable variables
 */

$DBname='/path/DB.sqlite'; #the filename of the SQLite database

/** NO NEED TO EDIT BELOW THIS LINE UNLESS YOU WANT TO MAKE CHANGES TO THE STANDARD WAY OF WORKING **/
?>

<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
<title>List of clicks</title>
<style type="text/css">
BODY,TABLE
{

        FONT-FAMILY:verdana,arial, sans-serif;
        color:#330000;
        font-size:x-small;
        font-weight:normal;
        empty-cells: show;
}
H1
{
        FONT-FAMILY:arial, sans-serif;
        /*color:#990000;*/
        color:#70809F;
        /*font-size:18px;*/
        font-size:xx-large;
        text-align:left;
        font-weight:bold;
        text-indent:0px;
        margin-left:20px;
        margin-right:20px;
        margin-top:0px;
        margin-bottom:20px;
}
</style>
</head>
<body>
<?php

/**
 * Open DB 
 */
try {
  $db = new PDO("sqlite:$DBname");
  $db->setAttribute( PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION );
  if(!isset($_GET['linkID']) || !isset($_GET['url']))
    list_Links($db);
  else
    list_Log($db,$_GET['linkID'],$_GET['url']);
  /**
   * Check if 'ct_Log' table exists
   */
  }
catch (PDOException $e) {
  print "Error!: " . $e->getMessage() . "<br/>";
  die();
}
/********************************
 * list_Links function displays a content of  ct_Links table
 ********************************/

function list_Links($db) {
  print '<h1>List of links</h1>';
  try{
    // check if ct_Log table exists */
    $stmt=$db->query("SELECT COUNT(*) FROM sqlite_master WHERE type='table' AND name='ct_Log'");
    if(intval($stmt->fetchColumn()))
      $ct_LogExists=1;
    else
      $ct_LogExists=0;
    // get the content of ct_Links table 
    $stmt=$db->query('SELECT * FROM ct_Links ORDER BY counter DESC');
    print "<table border='1'>\n";
    print "<tr>\n<th>URL</th><th>Number of clicks</th>\n</tr>\n";
    while( $row = $stmt->fetch(PDO::FETCH_ASSOC)){
      print "<tr>\n";
      print("<td><a href='" . $row['url']. "'>" .$row['url']. "</a></td>");
      //if  ct_Log table exists
      if($ct_LogExists){
	//then display a number of clicks as a link to results stored in ct_Log table
	$query_string= sprintf('%s?linkID=%s&url=%s',$_SERVER['PHP_SELF'], urlencode($row['linkID']), urlencode($row['url']));
	$query_string=htmlentities ($query_string);
	print("<td><a href='$query_string'>". $row['counter'] . "</a></td>\n");
      }
      else
	//if  ct_Log table doesn't exists, display a number of clicks
	print("<td>". $row['counter'] . "</td>\n");
      print "</tr>\n";
    }
  }
  catch (PDOException $e) {
    print "Error!: " . $e->getMessage() . "<br/>";
    die();
  }
  print "</table>\n";
}
/********************************
 * list_Log function displays a content of  ct_Log table
 ********************************/
function list_Log($db,$linkID,$url) {
  print "<h1>Who clicked '$url' link</h1>\n";
  print "<table border='1'>\n";
  print "<tr>\n<th>When</th><th>Hostname</th><th>Useragent</th>\n</tr>\n";
  try{
    // get the content of ct_Log table 
    $stmt=$db->prepare('SELECT  logTime,ip,useragent FROM ct_Log WHERE linkID = ?');
    $stmt->bindParam(1, $linkID);
    $stmt->execute();
    //display the content
    while( $row = $stmt->fetch(PDO::FETCH_ASSOC)){
      print "<tr>\n";
      print "<td>" . $row['logTime'] . "</td>";
      print "<td>" . $row['ip'] . "</td>";
      print "<td>" . $row['useragent'] . "</td>\n";
      print "</tr>\n";
    }
  }
  catch (PDOException $e) {
    print "Error!: " . $e->getMessage() . "<br/>";
    die();
  }
  print "</table>\n";
  print "<a href='" . $_SERVER['PHP_SELF'] . "'>Back to 'List of links'</a>";
}
?>
</body>
</html>



